#include <basepch.h>

#pragma hdrstop

#include "CommandLine.h"
#pragma package(smart_init)

//---------------------------------------------------------------------------
// ValidCtrCheck ́A`ꂽR|[lgz֐܂
// ۃNXł͂ȂƂmF邽߂ɒ`Ă܂B
// (generated C++Builder6)
//---------------------------------------------------------------------------
static inline void ValidCtrCheck(TCommandLine *)
{
    new TCommandLine(NULL);
}

//---------------------------------------------------------------------------
// DOS R}hsR|[lgNXRXgN^
//---------------------------------------------------------------------------
__fastcall TCommandLine::TCommandLine( TComponent* Owner )
	: TComponent( Owner ),  hReadPipe( NULL ), hWritePipe( NULL ),
	  FIsOnExecution( false ), FExitCode( 0 ), FPriority( dcpNormal ),
	  FOnOutputChar( NULL ), FOnOutputLine( NULL ), FOnTerminate( NULL ),
	  FEnv( new TStringList )
{
	ZeroMemory(&sa, sizeof( SECURITY_ATTRIBUTES));
	ZeroMemory(&sd, sizeof( SECURITY_DESCRIPTOR));
	ZeroMemory(&si, sizeof( STARTUPINFO));
	ZeroMemory(&pi, sizeof( PROCESS_INFORMATION));
}

//---------------------------------------------------------------------------
// DOS R}hsR|[lgNXfXgN^
//---------------------------------------------------------------------------
__fastcall TCommandLine::~TCommandLine()
{
	// R}hsȂ狭I
	Terminate();

	if ( pi.hProcess ) {
		CloseHandle( pi.hProcess );
	}
	if ( pi.hThread ) {
		CloseHandle( pi.hThread );
	}
	if ( hReadPipe ) {
		CloseHandle( hReadPipe );
	}
	if ( hWritePipe ) {
		CloseHandle( hWritePipe );
	}
}

//---------------------------------------------------------------------------
// DOS R}hs֐
//
//   command: R}h
//   Return : true  = 
//            false = s
//---------------------------------------------------------------------------
bool __fastcall TCommandLine::Execute(
const AnsiString& command,
const AnsiString& dir,
void* env)
{
	if ( FIsOnExecution ) {
		// łɎsȂ̂ false
		return false;
	}

	// ǂݍ݁EݗppCv쐬
	InitializeSecurityDescriptor( &sd, SECURITY_DESCRIPTOR_REVISION );
	SetSecurityDescriptorDacl( &sd, TRUE, NULL, FALSE );
	sa.nLength = sizeof( SECURITY_ATTRIBUTES );
	sa.bInheritHandle = TRUE;
	sa.lpSecurityDescriptor = &sd;
	if ( !CreatePipe( &hReadPipe, &hWritePipe, &sa, 256 ) ) {
		return false;
	}

	// WóEWG[o͂̃nhpCvɊ蓖Ă
	ZeroMemory( &si, sizeof( STARTUPINFO ) );
	si.cb = sizeof( STARTUPINFO );
	si.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_HIDE;
	si.hStdOutput = hWritePipe;
	si.hStdError = hWritePipe;

	// s DOS R}h Process Priority
	DWORD priority = NORMAL_PRIORITY_CLASS;
	switch ( FPriority ) {
		case dcpRealTime:
			priority = REALTIME_PRIORITY_CLASS;
			break;

		case dcpHigh:
			priority = HIGH_PRIORITY_CLASS;
			break;

		case dcpNormal:
			priority = NORMAL_PRIORITY_CLASS;
			break;

		case dcpIdle:
			priority = IDLE_PRIORITY_CLASS;
			break;
	}

	// R}hs
	if ( !CreateProcess( NULL, command.c_str(), NULL, NULL, TRUE,
			CREATE_NO_WINDOW | priority, (LPVOID)env, dir == "" ? NULL : dir.c_str(),
			&si, &pi ) ) {
		CloseHandle( hReadPipe );
		CloseHandle( hWritePipe );
		hReadPipe = NULL;
		hWritePipe = NULL;

		return false;
	}

	WaitForInputIdle( GetCurrentProcess(), INFINITE );

	CloseHandle( pi.hThread );
	pi.hThread = NULL;
	CloseHandle( hWritePipe );
	hWritePipe = NULL;

	// pCvǂݍݗpXbhNX쐬
	reader = new TPipeReader( true, this, hReadPipe, pi.hProcess,
		FOnOutputChar, FOnOutputLine );
	reader->OnTerminate = ProcessTerminate;
	reader->FreeOnTerminate = true;
	reader->Resume();

	// Ƃ肠 0 ɂĂ
	FExitCode = 0;

	FIsOnExecution = true;

	return true;
}

//---------------------------------------------------------------------------
// DOS R}hsI҂
//---------------------------------------------------------------------------
void __fastcall TCommandLine::WaitForTermination()
{
	if ( pi.hProcess ) {
		WaitForSingleObject( pi.hProcess, INFINITE );
		GetExitCodeProcess( pi.hProcess, &FExitCode );
	}
}

//---------------------------------------------------------------------------
// DOS R}hI
//---------------------------------------------------------------------------
void __fastcall TCommandLine::Terminate()
{
	if ( pi.hProcess ) {
		TerminateProcess( pi.hProcess, 0 );
		pi.hProcess = NULL;
	}
	if ( pi.hThread ) {
		TerminateThread( pi.hThread, 0 );
		pi.hThread = NULL;
	}
}

//---------------------------------------------------------------------------
// pCvǂݍݗpXbhIƂɌĂ΂֐
//---------------------------------------------------------------------------
void __fastcall TCommandLine::ProcessTerminate( TObject* /* Sender */ )
{
	GetExitCodeProcess( pi.hProcess, &FExitCode );

	if ( pi.hProcess ) {
		CloseHandle( pi.hProcess );
		pi.hProcess = NULL;
	}
	if ( pi.hThread ) {
		CloseHandle( pi.hThread );
		pi.hThread = NULL;
	}
	if ( hReadPipe ) {
		CloseHandle( hReadPipe );
		hReadPipe = NULL;
	}
	if ( hWritePipe ) {
		CloseHandle( hWritePipe );
		hWritePipe = NULL;
	}

	if ( FOnTerminate ) {
		FOnTerminate( this );
	}

	FIsOnExecution = false;

	if(reader->GetEnvFlag())
	{
		reader->SetEnvFlag(false);
	}
}

//---------------------------------------------------------------------------
// ϐ擾
//---------------------------------------------------------------------------
bool __fastcall TCommandLine::GetEnv()
{
	if(! Execute(AnsiString("cmd /C set"), "", NULL))  // ϐ擾R}hs
	{
		return false;
	}

	reader->SetEnvFlag(true);

	return true;
}

//---------------------------------------------------------------------------
// ϐubNTCY擾
//---------------------------------------------------------------------------
int __fastcall TCommandLine::GetEnvBlkSize()
{
	int size = 0;

	if(NULL == Env)
	{
		return(size);
	}

	for(int i = 0; i < Env->Count; i++)
	{
		size += Env->Strings[i].Length() + 1;
	}

	size++;  // ubN̏I[ NULL + NULL ł邽 + 1

	return(size);
}

//---------------------------------------------------------------------------
// ϐubN擾
//---------------------------------------------------------------------------
bool __fastcall TCommandLine::GetEnvBlk(int size, void* blk)
{
	int allSize = GetEnvBlkSize();

	if(size < allSize)
	{
		return(false);
	}

	char* ptr = (char*)blk;
	memset(ptr, 0x00, size);

	for(int i = 0; i < Env->Count; i++)
	{
		memcpy(ptr, Env->Strings[i].c_str(), Env->Strings[i].Length());
		ptr += Env->Strings[i].Length() + 1;
	}

	return(true);
}

//---------------------------------------------------------------------------
// pCv當ǂݎ邽߂̃XbhNXRXgN^
//---------------------------------------------------------------------------
__fastcall TCommandLine::TPipeReader::TPipeReader( bool CreateSuspended,
		TCommandLine* AnOwner, HANDLE hAReadPipe, HANDLE hAProcess,
		TGetCharProc AnOnOutputChar, TGetStringProc AnOnOutputLine )
	: TThread( CreateSuspended ), Owner( AnOwner ), hReadPipe( hAReadPipe ),
	  hProcess( hAProcess ), OnOutputChar( AnOnOutputChar ),
	  OnOutputLine( AnOnOutputLine ), EnvFlag( false )
{
}

//---------------------------------------------------------------------------
// TPipeReader XbhNXŎs֐
//---------------------------------------------------------------------------
void __fastcall TCommandLine::TPipeReader::Execute()
{
	// 1 sobt@NA
	LineBuffer = "";

	while ( !Terminated ) {
		DWORD bytesRead, exitCode;

		// vZX܂s̏ꍇ̓pCvɃf[^܂ő҂B
		// vZXIꍇ̓[v甲
		do {
			PeekNamedPipe( hReadPipe, &Buf, 1, &bytesRead, NULL, NULL );
			GetExitCodeProcess( hProcess, &exitCode );
			Sleep( 1 );
		} while ( bytesRead == 0 && exitCode == STILL_ACTIVE && !Terminated );

		// pCv當ǂݍ
		while ( bytesRead != 0 ) {
			// pCv 1 ǂݍ
			BOOL status = ReadFile( hReadPipe, &Buf, 1, &bytesRead, NULL );
			if ( status && bytesRead != 0 ) {
				Synchronize( CallOnOutputChar );
				if ( Buf == '\n' ) {
					// sR[hȂo͕󂯎֐֕]A
					// 1 sobt@NA
					Synchronize( CallOnOutputLine );
					LineBuffer = "";
				} else {
					// sR[hȊO 1 sobt@ɉ
					LineBuffer += AnsiString( Buf );
				}
			}
			PeekNamedPipe( hReadPipe, &Buf, 1, &bytesRead, NULL, NULL );
		}

		if ( exitCode != STILL_ACTIVE || Terminated ) {
			break;
		}
	}

	// sŏIȂȂ當o͂󂯎֐֓]
	if ( LineBuffer != "" ) {
		Synchronize( CallOnOutputLine );
	}
}

//---------------------------------------------------------------------------
// 1 o͂󂯎֐֕]
//---------------------------------------------------------------------------
void __fastcall TCommandLine::TPipeReader::CallOnOutputChar()
{
	if ( OnOutputChar ) {
		OnOutputChar( Owner, Buf );
	}
}

//---------------------------------------------------------------------------
// 1 s󂯎֐ 1 s]
//---------------------------------------------------------------------------
void __fastcall TCommandLine::TPipeReader::CallOnOutputLine()
{
	// ̍Ō̃LbW^[R[h
	int len = LineBuffer.Length();
	if ( LineBuffer[ len ] == '\r' ) {
		LineBuffer.SetLength( len - 1 );
	}

	// ϐvpeBŕێ
	if(EnvFlag)
	{
		Owner->Env->Add(LineBuffer);
		return;
	}

	// 1 s󂯎֐֓]
	if ( OnOutputLine ) {
		OnOutputLine( Owner, LineBuffer );
	}
}

//---------------------------------------------------------------------------
// ϐ擾tOݒ
//---------------------------------------------------------------------------
void __fastcall TCommandLine::TPipeReader::SetEnvFlag(bool flag)
{
    EnvFlag = flag;
}

//---------------------------------------------------------------------------
// ϐ擾tO擾
//---------------------------------------------------------------------------
bool __fastcall TCommandLine::TPipeReader::GetEnvFlag()
{
    return(EnvFlag);
}

//---------------------------------------------------------------------------
// R|[lgo^ (generated C++Builder6)
//---------------------------------------------------------------------------
namespace Commandline
{
    void __fastcall PACKAGE Register()
    {
         TComponentClass classes[1] = {__classid(TCommandLine)};
         RegisterComponents("Samples", classes, 0);
    }
}

